/*
	stringa.c
	25-05-2005

*/

#include "stringa.h"
#include <malloc.h>


static str s;

static int in(char x, char *t){
	while( *t && x != *t++ )
		;
	return *t;
}

void strNew(char *ss){
	s.s=malloc(strlen(ss)+1);
	strcpy(s.s,ss);
	s.i=-1;
}

void strDel(void){
	s.i=-1;
	free(s.s);
} 

void strTrim( void ) {	//sposta l'indice sul primo carattere diverso da spazio

	while(s.s[s.i] != '\0' && s.s[s.i] == ' ' )
		s.i++;
}

void strToken( char *tok ){

	strTrim();
	while(s.s[++s.i] != '\0' && !in(s.s[s.i],tok) )
		;
}

void scan( void ){
	s.i++;
	strTrim();
	if(s.s[s.i]>='0' && s.s[s.i]<='9') s.simb=COSTANTE; 
	if(s.s[s.i]=='+') s.simb=PIU;
	if(s.s[s.i]=='*') s.simb=PER;
	if(s.s[s.i]=='-') s.simb=MENO;
	if(s.s[s.i]=='/') s.simb=DIVISO;
	if(s.s[s.i]=='(') s.simb=APEPAR;
	if(s.s[s.i]==')') s.simb=CHIPAR;
	if(s.s[s.i]=='\0' || s.s[s.i]=='\n') s.simb=ALT;
}

int simbolo(void){
	return s.simb;
}

char *numero(void){
	char * x=malloc(8);
	int i=0;

	for(i=s.i; s.s[i]>='0' && s.s[i]<='9'; ++i)
		x[i-s.i]=s.s[i];
	x[i-s.i]='\0';
	s.i = i-1;
	return x;
}

void strPrint( void ){
	int i;
	printf("\n%s", s.s);
	for(i=0;i<s.i;++i)
		printf(" ");
	printf("^");
}
