/*
	tree.c
	versione semplificata per albero binario.
	1-05-2005

*/
#include <malloc.h>
#include "tree.h"

/* Costruttori  */

Tree treeCrea(void *d, void *sn, void *dt){
	Tree e = (Tree)malloc(sizeof(_Tree));

	e->dato = d;
	e->left = sn;
	e->right = dt;
	return e;
}

Tree treeVuoto( void ){
	return NULL;
}

/*  Selettori    */

DATO treeDato(Tree t){
	return t->dato;
}

Tree treeSin(Tree t){
	return t->left;
}
Tree treeDes(Tree t){
	return t->right;
}

/*  Controllo    */

int isTreeVuoto(Tree t){
	return t == NULL;
}
